
#include "io430.h"
#include "in430.h"

signed char counter=0;
unsigned char disp[6];
unsigned char led_index=0; 
const unsigned char tabelaseg[]={0x7E, 0x0D, 0xB6, 0x9E, 0xCC, 0xDA, 0xFA, 0x0E, 0xFE, 0xDE};

int main( void )
{
  // Stop watchdog timer to prevent time out reset
  WDTCTL = WDTPW + WDTHOLD;
  
  P4DIR=0xFE;//segmenti
  P4OUT=0x00;//svi segmenti iskljuceni
  P5DIR=0xC0;//selektovana dva displeja
  P5OUT=0x80;//ukljucen prvi displej
  
  P1IE=0x14;//dozvola prekida za tastere S3 i S4
  P1IES=0x14;//opadajuca ivica aktivira prekid
  
  TACCR0 = 327;//100Hz
  TACTL = TASSEL_1 + MC_1;                  // ACLK, up mode
  TACCTL0 = CCIE;                           // CCR0 interrupt enabled
  
  P3DIR=0x10;
  P3SEL=0x10;
  TBCCR0 = 100;                           // PWM Period
  TBCCTL3 = OUTMOD_7;                       // CCR3 reset/set
  TBCCR3 = 0x00;                             // CCR3 PWM duty cycle
  TBCTL = TBSSEL_1 + MC_1;                  // ACLK, up mode
  
  _EINT();//globalna dozvola prekida- intrinsic funkcija deklarisana u "in430.h"
   
  while(1) {//beskonacna petlja
  }   
}

// define the interrupt handler
#pragma vector=PORT1_VECTOR
__interrupt void port1Handler( void ){
  if (P1IFG&0x04){//taster S4
    counter++;
    if (counter==100) counter=0;
    disp[1]=counter/10;
    disp[0]=counter-disp[1]*10;
    TBCCR3=counter;
    P1IFG&=~0x04;//birsanje flag-ova. Ako se flag ne izbrise prekid ostaje aktivan
  }
  else {//taster S3
    counter--;
    if (counter==-1) counter=99;
    disp[1]=counter/10;
    disp[0]=counter-disp[1]*10;
    TBCCR3=counter;
    P1IFG&=~0x10;//birsanje flag-ova. Ako se flag ne izbrise prekid ostaje aktivan
  };  
};


// Timer A0 interrupt service routine
#pragma vector=TIMERA0_VECTOR
__interrupt void Timer_A (void)
{
  led_index++;
  if (led_index==2) led_index=0;
  switch(led_index){
    case 0:{//jedinice
      P5OUT=0x00;//iskljucuje sve displeje
      P4OUT=tabelaseg[disp[0]];
      P5OUT=0x80;
    };break;
    case 1:{//desetice
      P5OUT=0x00;//iskljucuje sve displeje
      P4OUT=tabelaseg[disp[1]];
      P5OUT=0x40;
    };break;  
  };
}



