#include "io430.h"
#include "in430.h"
#include "function.h"

unsigned char data;//podatak koji se ispisuje na displej

int main( void )
{
  // Stop watchdog timer to prevent time out reset
  WDTCTL = WDTPW + WDTHOLD;
  P4DIR=0xFE;//segmenti
  P5DIR=0x80;//selektovan prvi displej
  P5OUT=0x80;//ukljucen prvi displej
  P1IE=0x04;//dozvola prekida za taster S4
  P1IES=0x04;//opadajuca ivica aktivira prekid  
  P2SEL|=0x30;//funkcija pinova 4 i 5 porta 2 dodeljena uart-u
  ME1|=URXE0+UTXE0;//omogucavanje UART prijemnik i predajnik
  U0CTL=0x10;//8-bit characters
  U0TCTL=0x30;//UCLK = SMCLK
  U0BR0=0xB5;// 1,048576/2400  436.9=437=0x1B5
  U0BR1=0x01;
  IE1=0x40;
  _EINT();//funkcija dekalrisana u i430.h - globalna dozvola prekida
  while(1);
}

// define the interrupt handler
#pragma vector=PORT1_VECTOR
__interrupt void port1Handler( void ){
  U0TXBUF=data;//na pritisak tastera salje podatak
  P1IFG=P1IFG&~BIT2;//brise flag na pozicija bita 2
};

// define the interrupt handler
#pragma vector=UART0RX_VECTOR
__interrupt void uart0RxHandler( void ){
  data=U0RXBUF;//ocitava pristigli podatak
  WriteLed(data);
};
